#include <stdio.h>
#include <stdlib.h>

unsigned char *img;

#define R3(x, A, B, C, D) \
    ((double)(C) + ((double)(x)-(double)(A)) * ((double)(D)-(double)(C)) \
                                             / ((double)(B)-(double)(A)))

int main(int n, char **v)
{
  int w, h, x, y0, y1;
  int nc, c;
  int i;
  FILE *in;
  FILE *out1, *out2;
  if (n != 9) {
    printf("gimme <in> <width> <height> <x> <y0> <y1> <out 1> <out 2>\n");
    return 1; }
  sscanf(v[2], "%d", &w);
  sscanf(v[3], "%d", &h);
  sscanf(v[4], "%d", &x);
  sscanf(v[5], "%d", &y0);
  sscanf(v[6], "%d", &y1);
  if (y1 >= y0) { printf("we must have y1 < y0\n"); return 1; }
  img = malloc(3 * w* h); if (!img) { printf("err 0\n"); return 1; }
  in = fopen(v[1], "rb");
  out1 = fopen(v[7], "wb");
  out2 = fopen(v[8], "wb");
  if (!in || !out1 || !out2) { printf("err\n"); return 1; }
  fprintf(out1, "mapsize 4096\n");
  fprintf(out2, "mapsize 4096\n");
  nc = 0;
  while (nc != 3) {
    c = fgetc(in); if (c == EOF) { printf("err 2\n"); return 1; }
    if (c == '\n') nc++;
  }
  fread(img, w*h*3, 1, in);
  for (i = y0; i >= y1; i--) {
    unsigned char *col = img + (i * w + x) * 3;
    float r, g, b, v;
    v = R3(i, y0, y1, 0, 1);
    r = R3(*col, 0, 255, 0, 1);
    g = R3(*(col+1), 0, 255, 0, 1);
    b = R3(*(col+2), 0, 255, 0, 1);
    fprintf(out1, "colorb %g %g %g %g\n", v, r, g, b);
    fprintf(out2, "colorb %g %g %g %g\n", 1-v, r, g, b);
  }
  fprintf(out1, "buildmap\n");
  fprintf(out2, "buildmap\n");
  fprintf(out1, "dBmin -120\n");
  fprintf(out2, "dBmin -120\n");
  fprintf(out1, "dBmax 0\n");
  fprintf(out2, "dBmax 0\n");
  fclose(in);
  fclose(out1);
  fclose(out2);
  return 0;
}
