#ifndef _FFT_WINDOW_H_
#define _FFT_WINDOW_H_

#define NONE 0
#define BARTLETT 1
#define BLACKMAN 2
#define HAMMING 3
#define HANNING 4

typedef struct {
  double *b;
  int len;
  int type;
} fft_window;

#include "fft.h"

void fft_window_init(fft_window *, int, int);
void fft_window_close(fft_window *);
void fft_window_mul(fft_in *, fft_window *);
char *fft_window_string(fft_window *);
void fft_window_set_type(fft_window *, int);
void fft_window_type_from_string(fft_window *, const char *);

#endif /* _FFT_WINDOW_H_ */
