/* generated by gtkcooker (http://www.nongnu.org/gtkcooker) */

#include <gtk/gtk.h>
#include "gui.h"

#include "jackend.h"
#include "power_buffer.h"
#include "defs.h"
#include "colors.h"
#include "gui_colors.h"
#include "fft_window.h"



#include "commands.h"

#include <stdint.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#define RED 0
#define GREEN 1
#define ORANGE 2

void gui_widget_show_all(void *d)
{
  gtk_widget_show_all(d);
}

void gui_state(mainwin *this)
{
  char s[4096];
  float dB, Hz;
  if (!(this->pointer_x >= 0 && this->pointer_x < this->width &&
      this->pointer_y >= 0 && this->pointer_y < this->height))
    Hz = -1;
  else {
    float *buf = power_buffer_get_line(&this->f, this->pointer_x);
    float f = R3(this->pointer_y, 0, this->height-1,
                 this->max_freq, this->min_freq);
    int pos = R3(f, 0, this->jack->sample_rate, 0, this->f.fft.n);
    Hz = R3(pos, 0, this->f.fft.n, 0, this->jack->sample_rate);
    dB = buf[pos];
  }
  sprintf(s,
      "Hz [%g %g] fft [%d/%d/%g%%%s] dB/t [%g %g] dB/s [%g %g] %s",
      this->min_freq, this->max_freq,
      this->f.to_process, this->f.fft.n, this->f.overlap*100,
      fft_window_string(&this->f.window),
      this->mindB_stats_overall,
      this->maxdB_stats_overall,
      this->mindB_stats_show,
      this->maxdB_stats_show,
      this->redraw_lines == redraw_lines_nearest ? "nearest" : "average");
  gtk_label_set_text(GTK_LABEL(this->state_label), s);
  sprintf(s, "%-8.4g", this->colormap.mindB);
  gtk_label_set_text(GTK_LABEL(this->mindB_label), s);
  sprintf(s, "%-8.4g", this->colormap.maxdB);
  gtk_label_set_text(GTK_LABEL(this->maxdB_label), s);
  if (Hz == -1) {
    sprintf(s, "          ");
    gtk_label_set_text(GTK_LABEL(this->hz_label), s);
    sprintf(s, "          ");
    gtk_label_set_text(GTK_LABEL(this->db_label), s);
  } else {
    sprintf(s, "%-8.2fHz", Hz);
    gtk_label_set_text(GTK_LABEL(this->hz_label), s);
    sprintf(s, "%-8.2fdB", dB);
    gtk_label_set_text(GTK_LABEL(this->db_label), s);
  }
}

void color_red(mainwin *this, unsigned long n)
{
  char s[64];
  PangoColor _pango_color;
  GdkColor _color;
  sprintf(s, "%lu", n);
  gtk_label_set_text(GTK_LABEL(this->color_label), s);
  if (this->current_color == RED) return;
  this->current_color = RED;
  if (pango_color_parse(&_pango_color, "#f00")) {
    _color.red = _pango_color.red;
    _color.green = _pango_color.green;
   _color.blue = _pango_color.blue;
    gtk_widget_modify_bg((GtkWidget *)this->color_label_draw,
                         GTK_STATE_NORMAL, &_color);
  }
}

void color_green(mainwin *this)
{
  PangoColor _pango_color;
  GdkColor _color;
  if (this->current_color == GREEN) return;
  this->current_color = GREEN;
  if (pango_color_parse(&_pango_color, "#0f0")) {
    _color.red = _pango_color.red;
    _color.green = _pango_color.green;
   _color.blue = _pango_color.blue;
    gtk_widget_modify_bg((GtkWidget *)this->color_label_draw,
                         GTK_STATE_NORMAL, &_color);
  }
  gtk_label_set_text(GTK_LABEL(this->color_label), "OK");
}

void color_orange(mainwin *this)
{
  PangoColor _pango_color;
  GdkColor _color;
  if (this->current_color == ORANGE) return;
  this->current_color = ORANGE;
  if (pango_color_parse(&_pango_color, "orange")) {
    _color.red = _pango_color.red;
    _color.green = _pango_color.green;
   _color.blue = _pango_color.blue;
    gtk_widget_modify_bg((GtkWidget *)this->color_label_draw,
                         GTK_STATE_NORMAL, &_color);
  }
  gtk_label_set_text(GTK_LABEL(this->color_label), "PAUSE");
}

void gui_init(void)
{
  gtk_init(0, 0);
}

void gui_quit(void)
{
  gtk_main_quit();
}

void gui_show(mainwin *w)
{
  gtk_widget_show_all(w->win);
}

void gui_run(void)
{
  gtk_main();
}

static void jack_callback(void *_this)
{
  unsigned long skipped = 0;
  mainwin *this = _this;
  int count = 0;
  int n;
  uint32_t ns;
  /* TODO: no partial read taken into account */
  while ((n = read(this->jack->jackfd, &ns, 4)) == 4) {
    count++;
    skipped += ns;
  }
  skipped -= ns;
  if (!(n == -1 && errno == EAGAIN)) { printf("read error\n"); exit(1); }
  if (count != 1) {
    this->lost_samples += skipped;
    color_red(this, this->lost_samples);
  }
  power_buffer_feed(&this->f, this->jack->buffer, ns);
}

static gboolean _jack_callback(GIOChannel *source, GIOCondition condition,
                               gpointer _this)
{
  jack_callback(_this);
  return TRUE;
}

static void power_new_line(void *_this)
{
  int j;
  mainwin *this = _this;
  float v;

  for (j = 0; j < this->height; j++) {
    memmove(this->image + j * this->width * 3,
            this->image + j * this->width * 3 + 3,
            (this->width-1) * 3);
  }

  this->redraw_lines(this, this->width-1, this->width-1);

  memmove(this->dsamples_min, this->dsamples_min+1, this->width-1);
  memmove(this->dsamples_max, this->dsamples_max+1, this->width-1);

  v = R3(this->f.buf_min, -1, 1, 0, 41);
  if (v < 0) v = 0;
  if (v > 41) v = 41;
  this->dsamples_min[this->width-1] = v;
  v = R3(this->f.buf_max, -1, 1, 0, 41);
  if (v < 0) v = 0;
  if (v > 41) v = 41;
  this->dsamples_max[this->width-1] = v;
  this->f.buf_min = 10000;
  this->f.buf_max = -10000;

  gui_state(this);
}

void gui_force_redraw(mainwin *this)
{
  gtk_widget_queue_draw(this->d);
  gtk_widget_queue_draw(this->dsamples);
}

void gui_force_redraw_colors(mainwin *this)
{
  gtk_widget_queue_draw(this->dcol);
}

static void redraw(mainwin *this)
{
  gdk_draw_rgb_image(GTK_WIDGET(this->d)->window,
      GTK_WIDGET(this->d)->style->black_gc, 0, 0, this->width, this->height,
      /* dith */ 0,
      this->image, this->width*3);
}

static void colors_redraw(mainwin *this)
{
  gdk_draw_rgb_image(GTK_WIDGET(this->dcol)->window,
      GTK_WIDGET(this->d)->style->black_gc, 0, 0, 10, this->col_height,
      /* dith */ 0,
      this->colors_image, 10*3);
}

static void dsamples_redraw(mainwin *this)
{
  int i;
  for (i = 0; i < this->width; i++) {
    gdk_draw_line(GTK_WIDGET(this->dsamples)->window,
                  GTK_WIDGET(this->dsamples)->style->fg_gc[GTK_STATE_NORMAL],
                  i, this->dsamples_min[i],
                  i, this->dsamples_max[i]);
  }
}

void gui_pause_unpause(mainwin *this)
{
  this->jack->paused = 1 - this->jack->paused;
  if (this->jack->paused)
    color_orange(this);
  else {
    if (this->lost_samples)
      color_red(this, this->lost_samples);
    else
      color_green(this);
  }
}

static gboolean stats_timer(gpointer _this)
{
  mainwin *this = _this;
  if (this->f.mindB_stats == 10000) {
    this->mindB_stats_show = -1000;
    this->maxdB_stats_show = -1000;
  } else {
    this->mindB_stats_show = this->f.mindB_stats;
    this->maxdB_stats_show = this->f.maxdB_stats;
    if (this->mindB_stats_show < this->mindB_stats_overall)
      this->mindB_stats_overall = this->mindB_stats_show;
    if (this->maxdB_stats_show > this->maxdB_stats_overall)
      this->maxdB_stats_overall = this->maxdB_stats_show;
  }
  this->f.mindB_stats = 10000;
  this->f.maxdB_stats = -10000;
  gui_state(this);
  return TRUE;
}

static gboolean d_resize(GtkWidget *_widget, GdkEventConfigure *_event,
                         mainwin *this)
{
  int height = _event->height;
  int width = _event->width;
  if (height < 10) height = 10;
  if (width < 10) width = 10;
  if (height == this->height && width == this->width) return TRUE;
  free(this->image);
  this->image = malloc(width * height * 3);
  if (!this->image) { printf("oom\n"); exit(1); }
  if (width != this->width) {
    unsigned char *dsamples_min = malloc(width);
    unsigned char *dsamples_max = malloc(width);
    float *power = malloc(sizeof(float) * width * (this->f.fft.n/2+1));
    int i;
    int min_width;
    if (!dsamples_min || !dsamples_max || !power) { printf("oom\n"); exit(1); }
    memset(dsamples_min, 20, width);
    memset(dsamples_max, 20, width);
    min_width = width < this->width ? width : this->width;
    for (i = 0; i < min_width; i++) {
      dsamples_min[width-1 - i] = this->dsamples_min[this->width-1 - i];
      dsamples_max[width-1 - i] = this->dsamples_max[this->width-1 - i];
    }
    free(this->dsamples_min);
    free(this->dsamples_max);
    this->dsamples_min = dsamples_min;
    this->dsamples_max = dsamples_max;
    for (i = 0; i < width * (this->f.fft.n/2+1); i++)
      power[i] = -120;
    for (i = 0; i < min_width; i++) {
      memcpy(power + (width-1 - i) * (this->f.fft.n/2+1),
             power_buffer_get_line(&this->f, this->width-1 - i),
             sizeof(float) * (this->f.fft.n/2+1));
    }
    free(this->f.power);
    this->f.power = power;
    this->f.line = 0;
    this->f.width = width;
  }
  this->width = width;
  this->height = height;
  this->redraw_lines(this, 0, width-1);
  return TRUE;
}

static gboolean dcol_resize(GtkWidget *_widget, GdkEventConfigure *_event,
                            mainwin *this)
{
  int height = _event->height;
  if (height < 10) height = 10;
  if (height == this->col_height) return TRUE;
  this->col_height = height;
  free(this->colors_image);
  this->colors_image = malloc(this->col_height * 10 * 3);
  if (!this->colors_image) { printf("oom\n"); exit(1); }
  redraw_lines_colors(this);
  return TRUE;
}




#include <fcntl.h>

void repl(void *_this)
{
  mainwin *this = _this;
  char c[128];
  int l;
  memset(c, 0, 128);
  if (read(0, c, 127));
  l = strlen(c); if (!l) return;
  if (c[l-1] == '\n') c[l-1] = 0;
  do_command(this, c);
  printf("> "); fflush(stdout);
}

void init_repl(mainwin *w)
{
  long f;
  f = fcntl(0, F_GETFL); if (f == -1) exit(1);
  f |= O_NONBLOCK;
  if (fcntl(0, F_SETFL, f) == -1) exit(1);
  gtk_input_add_full(0, GDK_INPUT_READ, (GdkInputFunction)repl, 0, w, 0);
  printf("> "); fflush(stdout);
}


static void _1(GtkEntry *_widget, mainwin *this)
{
  {
    do_command(this, gtk_entry_get_text(GTK_ENTRY(this->command)));
    gtk_entry_set_text(GTK_ENTRY(this->command), "");
  }
}

static gboolean _2(GtkWidget *_widget, GdkEventExpose *_event, mainwin *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  { redraw(this); if (0) { height++; width++; x++; y++; } }
  return TRUE;
}

static gboolean _3(GtkWidget *_widget, GdkEventCrossing *_event, mainwin *this)
{
  int x = _event->x;
  int y = _event->y;
  
  { this->pointer_x = x; this->pointer_y = y; gui_state(this); }
  return TRUE;
}

static gboolean _4(GtkWidget *_widget, GdkEventCrossing *_event, mainwin *this)
{
  int x = _event->x;
  int y = _event->y;
  
  { this->pointer_x = -1; gui_state(this); if (0) { x++; y++; } }
  return TRUE;
}

static gboolean _5(GtkWidget *_widget, GdkEvent *_event, mainwin *this)
{
  int x;
  int y;
  GdkEventType type = _event->type;
  int button;
  switch (type) {
    default: return FALSE;
    case GDK_MOTION_NOTIFY:
      x = _event->motion.x;
      y = _event->motion.y;
      break;
    case GDK_BUTTON_PRESS:
    case GDK_2BUTTON_PRESS:
    case GDK_3BUTTON_PRESS:
    case GDK_BUTTON_RELEASE:
      x = _event->button.x;
      y = _event->button.y;
      button = _event->button.button;
      break;
  }
  
  {
    if (type == GDK_MOTION_NOTIFY) {
      this->pointer_x = x;
      this->pointer_y = y;
      gui_state(this);
      /* dirty hack begin */
      static int recur = 0;
      static volatile int sx, sy;
      sx = x;
      sy = y;
      if (recur) return TRUE;
      recur = 1;
      while (gtk_events_pending()) gtk_main_iteration();
      /* should test quit/change of state of GUI (hell, I hate this hack) */
      recur = 0;
      x = sx;
      y = sy;
      /* dirty hack end */
#if 0
      /* first version of hack, totally non-working */
      while (1) {
        GdkEvent *ev = gdk_event_get();
        if (ev == NULL) break;
        if (ev->type != GDK_MOTION_NOTIFY) {
          gdk_event_put(ev);
          gdk_event_free(ev);
          break;
        }
        x = ev->motion.x;
        y = ev->motion.y;
        gdk_event_free(ev);
      }
#endif
      gui_mouse_move(this, x, y);
      return TRUE;
    }
    if (type == GDK_BUTTON_RELEASE) {
      if (button == 3) return TRUE;
      gui_mouse_unclick(this); return TRUE;
    }
    if (type == GDK_BUTTON_PRESS) {
      int modifier = _event->button.state;
      int has_shift = modifier & GDK_SHIFT_MASK;
      int has_control = modifier & GDK_CONTROL_MASK;
      if (button == 3) {
        gtk_menu_popup(this->start_menu, NULL, NULL, NULL, NULL,
                       3, _event->button.time);
        return TRUE;
      }
      gui_mouse_click(this, x, y, has_shift, has_control);
      return TRUE;
    }
  }
  return TRUE;
}

static gboolean _6(GtkWidget *_widget, GdkEventExpose *_event, mainwin *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  { colors_redraw(this); if (0) { height++;width++;x++;y++; } }
  return TRUE;
}

static gboolean _7(GtkWidget *_widget, GdkEvent *_event, mainwin *this)
{
  int x;
  int y;
  GdkEventType type = _event->type;
  int button;
  switch (type) {
    default: return FALSE;
    case GDK_MOTION_NOTIFY:
      x = _event->motion.x;
      y = _event->motion.y;
      break;
    case GDK_BUTTON_PRESS:
    case GDK_2BUTTON_PRESS:
    case GDK_3BUTTON_PRESS:
    case GDK_BUTTON_RELEASE:
      x = _event->button.x;
      y = _event->button.y;
      button = _event->button.button;
      break;
  }
  
  {
    if (type == GDK_MOTION_NOTIFY) {
      /* dirty hack begin */
      static int recur = 0;
      static volatile int sx, sy;
      sx = x;
      sy = y;
      if (recur) return TRUE;
      recur = 1;
      while (gtk_events_pending()) gtk_main_iteration();
      /* should test quit/change of state of GUI (hell, I hate this hack) */
      recur = 0;
      x = sx;
      y = sy;
      /* dirty hack end */
      gui_colors_mouse_move(this, x, y);
      return TRUE;
    }
    if (type == GDK_BUTTON_RELEASE) {
      gui_colors_mouse_unclick(this);
      return TRUE;
    }
    if (type == GDK_BUTTON_PRESS) {
      gui_colors_mouse_click(this, x, y);
      return TRUE;
    }
  }
  return TRUE;
}

static gboolean _8(GtkWidget *_widget, GdkEventExpose *_event, mainwin *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  { dsamples_redraw(this);if(0){height++;width++;x++;y++;}}
  return TRUE;
}

static gboolean _9(GtkWidget *_widget, GdkEvent *_event, mainwin *this)
{
  int x;
  int y;
  GdkEventType type = _event->type;
  int button;
  switch (type) {
    default: return FALSE;
    case GDK_MOTION_NOTIFY:
      x = _event->motion.x;
      y = _event->motion.y;
      break;
    case GDK_BUTTON_PRESS:
    case GDK_2BUTTON_PRESS:
    case GDK_3BUTTON_PRESS:
    case GDK_BUTTON_RELEASE:
      x = _event->button.x;
      y = _event->button.y;
      button = _event->button.button;
      break;
  }
  
  {
    if (type != GDK_BUTTON_PRESS) return TRUE;
    if (button == 3) {
      this->mindB_stats_overall = 10000;
      this->maxdB_stats_overall = -10000;
    } else if (button == 1) {
      if (this->jack->paused) return TRUE;
      this->lost_samples = 0;
      color_green(this);
    }
  }
  return TRUE;
}

static void _16(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "cs");}
}

static void _18(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "p");}
}

static void _20(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "h");}
}

static void _22(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "q");}
}

static void _24(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 128");}
}

static void _26(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 256");}
}

static void _28(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 512");}
}

static void _30(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 1024");}
}

static void _32(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 2048");}
}

static void _34(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 4096");}
}

static void _36(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 8192");}
}

static void _38(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 16384");}
}

static void _40(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 32768");}
}

static void _42(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 65536");}
}

static void _44(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 131072");}
}

static void _46(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 262144");}
}

static void _48(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "s 524288");}
}

static void _50(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 0.0");}
}

static void _52(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 0.1");}
}

static void _54(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 0.2");}
}

static void _56(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 0.3");}
}

static void _58(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 0.4");}
}

static void _60(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 0.5");}
}

static void _62(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 0.6");}
}

static void _64(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 0.7");}
}

static void _66(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 0.8");}
}

static void _68(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 0.9");}
}

static void _70(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "o 1.0");}
}

static void _72(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "w nn");}
}

static void _74(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "w ba");}
}

static void _76(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "w bl");}
}

static void _78(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "w hm");}
}

static void _80(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "w hn");}
}

static void _82(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "nr");}
}

static void _84(GtkMenuItem *_widget, mainwin *this)
{
  {do_command(this, "av");}
}

/* returns -1 on error, 0 if everything is fine */
int init_mainwin(mainwin *this, jack_stuff *jack)
{
  GtkWidget *_0;
  GtkWidget *lb;
  GtkWidget *rb;
  GtkWidget *rb2;
  GtkWidget *color_label_box;
  GtkWidget *command_box;
  GtkWidget *main_menu_button;
  GtkWidget *_10;
  GtkWidget *main_menu;
  GtkWidget *main_menu_0;
  GtkWidget *_11;
  GtkWidget *start_menu_0;
  GtkWidget *_12;
  GtkWidget *start_menu_1;
  GtkWidget *_13;
  GtkWidget *start_menu_2;
  GtkWidget *_14;
  GtkWidget *start_menu_4;
  GtkWidget *_15;
  GtkWidget *start_menu_6;
  GtkWidget *_17;
  GtkWidget *start_menu_8;
  GtkWidget *_19;
  GtkWidget *start_menu_10;
  GtkWidget *_21;
  GtkWidget *start_menu_11;
  GtkWidget *_23;
  GtkWidget *fft_size_menu;
  GtkWidget *fft_size_menu_0;
  GtkWidget *_25;
  GtkWidget *fft_size_menu_1;
  GtkWidget *_27;
  GtkWidget *fft_size_menu_2;
  GtkWidget *_29;
  GtkWidget *fft_size_menu_3;
  GtkWidget *_31;
  GtkWidget *fft_size_menu_4;
  GtkWidget *_33;
  GtkWidget *fft_size_menu_5;
  GtkWidget *_35;
  GtkWidget *fft_size_menu_6;
  GtkWidget *_37;
  GtkWidget *fft_size_menu_7;
  GtkWidget *_39;
  GtkWidget *fft_size_menu_8;
  GtkWidget *_41;
  GtkWidget *fft_size_menu_9;
  GtkWidget *_43;
  GtkWidget *fft_size_menu_10;
  GtkWidget *_45;
  GtkWidget *fft_size_menu_11;
  GtkWidget *_47;
  GtkWidget *fft_size_menu_12;
  GtkWidget *_49;
  GtkWidget *fft_overlap_menu;
  GtkWidget *fft_overlap_menu_0;
  GtkWidget *_51;
  GtkWidget *fft_overlap_menu_1;
  GtkWidget *_53;
  GtkWidget *fft_overlap_menu_2;
  GtkWidget *_55;
  GtkWidget *fft_overlap_menu_3;
  GtkWidget *_57;
  GtkWidget *fft_overlap_menu_4;
  GtkWidget *_59;
  GtkWidget *fft_overlap_menu_5;
  GtkWidget *_61;
  GtkWidget *fft_overlap_menu_6;
  GtkWidget *_63;
  GtkWidget *fft_overlap_menu_7;
  GtkWidget *_65;
  GtkWidget *fft_overlap_menu_8;
  GtkWidget *_67;
  GtkWidget *fft_overlap_menu_9;
  GtkWidget *_69;
  GtkWidget *fft_overlap_menu_10;
  GtkWidget *_71;
  GtkWidget *fft_window_menu;
  GtkWidget *fft_window_menu_0;
  GtkWidget *_73;
  GtkWidget *fft_window_menu_1;
  GtkWidget *_75;
  GtkWidget *fft_window_menu_2;
  GtkWidget *_77;
  GtkWidget *fft_window_menu_3;
  GtkWidget *_79;
  GtkWidget *fft_window_menu_4;
  GtkWidget *_81;
  GtkWidget *display_menu;
  GtkWidget *display_menu_0;
  GtkWidget *_83;
  GtkWidget *display_menu_1;
  GtkWidget *_85;
  GtkWidget *_86;
  GtkWidget *_87;
  GtkWidget *_88;
  GtkWidget *_89;
  GtkWidget *_90;
  GtkWidget *_91;
  GtkWidget *_92;
  GtkWidget *_93;
  GtkWidget *_94;
  GtkWidget *_95;
  GtkWidget *_96;
  GtkWidget *_97;
  GtkWidget *_98;
  GtkWidget *_99;

  {
#define WIDTH 800
#define HEIGHT 400
    if (default_colormap(&this->colormap) == -1) exit(1);
    this->jack = jack;
    this->image = malloc(WIDTH*HEIGHT*3);
    if (!this->image) { printf("oom\n"); exit(1); }
    memset(this->image, 0, WIDTH*HEIGHT*3);
    this->colors_image = malloc(10*HEIGHT*3);
    if (!this->colors_image) { printf("oom\n"); exit(1); }
    memset(this->colors_image, 0, 10*HEIGHT*3);
    this->dsamples_min = malloc(WIDTH);
    this->dsamples_max = malloc(WIDTH);
    if (!this->dsamples_min || !this->dsamples_max) {printf("oom\n");exit(1);}
    memset(this->dsamples_min, 20, WIDTH);
    memset(this->dsamples_max, 20, WIDTH);
    power_buffer_init(&this->f, WIDTH, 8192, power_new_line, this, BARTLETT);
    this->width = WIDTH;
    this->height = HEIGHT;
    this->col_height = HEIGHT;
    this->min_freq = 0;
    this->max_freq = jack->sample_rate / 2;
    this->mouse_state = 0;
    this->mouse_colors_state = 0;
    this->lost_samples = 0;
    this->mindB_stats_show = -1000;
    this->maxdB_stats_show = -1000;
    this->mindB_stats_overall = 10000;
    this->maxdB_stats_overall = -10000;
    this->current_color = -1;
    this->colmap.shown = 0;
    this->redraw_lines = redraw_lines_nearest;
    this->pointer_x = -1;
    this->pointer_y = -1;
  }

  this->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->win),
        (GtkWidget *)this->win, &_geo, GDK_HINT_MIN_SIZE);
  }
  _0 = gtk_vbox_new(FALSE, 0);
  lb = gtk_vbox_new(FALSE, 0);
  rb = gtk_vbox_new(FALSE, 0);
  rb2 = gtk_vbox_new(FALSE, 0);
  color_label_box = gtk_vbox_new(FALSE, 0);
  command_box = gtk_hbox_new(FALSE, 0);
  this->mindB_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->mindB_label), "");
  gtk_misc_set_alignment(GTK_MISC(this->mindB_label), 0.500000, 1.000000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)this->mindB_label, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->maxdB_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->maxdB_label), "");
  gtk_misc_set_alignment(GTK_MISC(this->maxdB_label), 0.500000, 0.000000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)this->maxdB_label, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->hz_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->hz_label), "");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)this->hz_label, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->db_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->db_label), "");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)this->db_label, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->color_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->color_label), "");
  gtk_misc_set_alignment(GTK_MISC(this->color_label), 0.500000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("6");
    gtk_widget_modify_font((GtkWidget *)this->color_label, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->state_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->state_label), "");
  gtk_misc_set_alignment(GTK_MISC(this->state_label), 0.000000, 0.500000);
  this->command = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(this->command),
    "help (press enter)");
  gtk_widget_set_size_request((GtkWidget *)this->command, 150, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)this->command, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->d = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->d, 800, 400);
  this->dcol = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->dcol, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->dcol, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->dcol, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->dcol, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->dcol, 10, 400);
  this->dsamples = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->dsamples, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->dsamples, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->dsamples, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->dsamples, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->dsamples, 800, 41);
  this->color_label_draw = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->color_label_draw, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->color_label_draw, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->color_label_draw, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->color_label_draw, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->color_label_draw, 40, 20);
  main_menu_button = gtk_button_new();
  _10 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_10), "_Start");
  main_menu = gtk_menu_bar_new();
  main_menu_0 = gtk_menu_item_new();
  _11 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_11), "_Start");
  gtk_misc_set_alignment(GTK_MISC(_11), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_11, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->start_menu = gtk_menu_new();
  start_menu_0 = gtk_menu_item_new();
  _12 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_12), "FFT _size");
  gtk_misc_set_alignment(GTK_MISC(_12), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_12, _font_desc);
    pango_font_description_free(_font_desc);
  }
  start_menu_1 = gtk_menu_item_new();
  _13 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_13), "FFT _overlap");
  gtk_misc_set_alignment(GTK_MISC(_13), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_13, _font_desc);
    pango_font_description_free(_font_desc);
  }
  start_menu_2 = gtk_menu_item_new();
  _14 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_14), "FFT _window");
  gtk_misc_set_alignment(GTK_MISC(_14), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_14, _font_desc);
    pango_font_description_free(_font_desc);
  }
  start_menu_4 = gtk_menu_item_new();
  _15 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_15), "_Display");
  gtk_misc_set_alignment(GTK_MISC(_15), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_15, _font_desc);
    pango_font_description_free(_font_desc);
  }
  start_menu_6 = gtk_menu_item_new();
  _17 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_17), "_Colormaps");
  gtk_misc_set_alignment(GTK_MISC(_17), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_17, _font_desc);
    pango_font_description_free(_font_desc);
  }
  start_menu_8 = gtk_menu_item_new();
  _19 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_19), "(un)_Pause");
  gtk_misc_set_alignment(GTK_MISC(_19), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_19, _font_desc);
    pango_font_description_free(_font_desc);
  }
  start_menu_10 = gtk_menu_item_new();
  _21 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_21), "_Help");
  gtk_misc_set_alignment(GTK_MISC(_21), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_21, _font_desc);
    pango_font_description_free(_font_desc);
  }
  start_menu_11 = gtk_menu_item_new();
  _23 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_23), "_Quit");
  gtk_misc_set_alignment(GTK_MISC(_23), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_23, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu = gtk_menu_new();
  fft_size_menu_0 = gtk_menu_item_new();
  _25 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_25), "128");
  gtk_misc_set_alignment(GTK_MISC(_25), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_25, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_1 = gtk_menu_item_new();
  _27 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_27), "256");
  gtk_misc_set_alignment(GTK_MISC(_27), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_27, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_2 = gtk_menu_item_new();
  _29 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_29), "512");
  gtk_misc_set_alignment(GTK_MISC(_29), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_29, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_3 = gtk_menu_item_new();
  _31 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_31), "1024");
  gtk_misc_set_alignment(GTK_MISC(_31), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_31, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_4 = gtk_menu_item_new();
  _33 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_33), "2048");
  gtk_misc_set_alignment(GTK_MISC(_33), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_33, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_5 = gtk_menu_item_new();
  _35 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_35), "4096");
  gtk_misc_set_alignment(GTK_MISC(_35), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_35, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_6 = gtk_menu_item_new();
  _37 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_37), "8192");
  gtk_misc_set_alignment(GTK_MISC(_37), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_37, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_7 = gtk_menu_item_new();
  _39 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_39), "16384");
  gtk_misc_set_alignment(GTK_MISC(_39), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_39, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_8 = gtk_menu_item_new();
  _41 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_41), "32768");
  gtk_misc_set_alignment(GTK_MISC(_41), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_41, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_9 = gtk_menu_item_new();
  _43 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_43), "65536");
  gtk_misc_set_alignment(GTK_MISC(_43), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_43, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_10 = gtk_menu_item_new();
  _45 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_45), "131072");
  gtk_misc_set_alignment(GTK_MISC(_45), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_45, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_11 = gtk_menu_item_new();
  _47 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_47), "262144");
  gtk_misc_set_alignment(GTK_MISC(_47), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_47, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_size_menu_12 = gtk_menu_item_new();
  _49 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_49), "524288");
  gtk_misc_set_alignment(GTK_MISC(_49), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_49, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu = gtk_menu_new();
  fft_overlap_menu_0 = gtk_menu_item_new();
  _51 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_51), "0%");
  gtk_misc_set_alignment(GTK_MISC(_51), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_51, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu_1 = gtk_menu_item_new();
  _53 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_53), "10%");
  gtk_misc_set_alignment(GTK_MISC(_53), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_53, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu_2 = gtk_menu_item_new();
  _55 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_55), "20%");
  gtk_misc_set_alignment(GTK_MISC(_55), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_55, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu_3 = gtk_menu_item_new();
  _57 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_57), "30%");
  gtk_misc_set_alignment(GTK_MISC(_57), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_57, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu_4 = gtk_menu_item_new();
  _59 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_59), "40%");
  gtk_misc_set_alignment(GTK_MISC(_59), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_59, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu_5 = gtk_menu_item_new();
  _61 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_61), "50%");
  gtk_misc_set_alignment(GTK_MISC(_61), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_61, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu_6 = gtk_menu_item_new();
  _63 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_63), "60%");
  gtk_misc_set_alignment(GTK_MISC(_63), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_63, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu_7 = gtk_menu_item_new();
  _65 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_65), "70%");
  gtk_misc_set_alignment(GTK_MISC(_65), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_65, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu_8 = gtk_menu_item_new();
  _67 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_67), "80%");
  gtk_misc_set_alignment(GTK_MISC(_67), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_67, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu_9 = gtk_menu_item_new();
  _69 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_69), "90%");
  gtk_misc_set_alignment(GTK_MISC(_69), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_69, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_overlap_menu_10 = gtk_menu_item_new();
  _71 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_71), "100%");
  gtk_misc_set_alignment(GTK_MISC(_71), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_71, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_window_menu = gtk_menu_new();
  fft_window_menu_0 = gtk_menu_item_new();
  _73 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_73), "None");
  gtk_misc_set_alignment(GTK_MISC(_73), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_73, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_window_menu_1 = gtk_menu_item_new();
  _75 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_75), "Bartlett");
  gtk_misc_set_alignment(GTK_MISC(_75), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_75, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_window_menu_2 = gtk_menu_item_new();
  _77 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_77), "Blackman");
  gtk_misc_set_alignment(GTK_MISC(_77), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_77, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_window_menu_3 = gtk_menu_item_new();
  _79 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_79), "Hamming");
  gtk_misc_set_alignment(GTK_MISC(_79), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_79, _font_desc);
    pango_font_description_free(_font_desc);
  }
  fft_window_menu_4 = gtk_menu_item_new();
  _81 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_81), "Hanning");
  gtk_misc_set_alignment(GTK_MISC(_81), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_81, _font_desc);
    pango_font_description_free(_font_desc);
  }
  display_menu = gtk_menu_new();
  display_menu_0 = gtk_menu_item_new();
  _83 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_83), "Nearest");
  gtk_misc_set_alignment(GTK_MISC(_83), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_83, _font_desc);
    pango_font_description_free(_font_desc);
  }
  display_menu_1 = gtk_menu_item_new();
  _85 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_85), "Average");
  gtk_misc_set_alignment(GTK_MISC(_85), 0.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)_85, _font_desc);
    pango_font_description_free(_font_desc);
  }
  _86 = gtk_hbox_new(FALSE, 4);
  _87 = gtk_hbox_new(FALSE, 0);
  _88 = gtk_hbox_new(FALSE, 0);
  _89 = gtk_hbox_new(FALSE, 0);
  _90 = gtk_hbox_new(FALSE, 0);
  _91 = gtk_hbox_new(FALSE, 0);
  _92 = gtk_hbox_new(FALSE, 0);
  _93 = gtk_hbox_new(FALSE, 0);
  _94 = gtk_hbox_new(FALSE, 0);
  _95 = gtk_hbox_new(FALSE, 0);
  _96 = gtk_hbox_new(FALSE, 0);
  _97 = gtk_hbox_new(FALSE, 0);
  _98 = gtk_vbox_new(FALSE, 0);
  _99 = gtk_vbox_new(FALSE, 0);

  gtk_container_add(GTK_CONTAINER(this->win), (GtkWidget *)_0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_86, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_87, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(lb), (GtkWidget *)_88, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(lb), (GtkWidget *)_89, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(rb), (GtkWidget *)_90, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(rb), (GtkWidget *)_91, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(rb2), (GtkWidget *)_92, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(rb2), (GtkWidget *)_93, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(rb2), (GtkWidget *)_94, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(rb2), (GtkWidget *)_95, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(color_label_box), (GtkWidget *)_96, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(color_label_box), (GtkWidget *)_97, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(command_box), (GtkWidget *)_98, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(command_box), (GtkWidget *)_99, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(main_menu_button), (GtkWidget *)_10);
  gtk_menu_shell_append(GTK_MENU_SHELL(main_menu), (GtkWidget *)main_menu_0);
  gtk_container_add(GTK_CONTAINER(main_menu_0), (GtkWidget *)_11);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(main_menu_0), (GtkWidget *)this->start_menu);
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), (GtkWidget *)start_menu_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), (GtkWidget *)start_menu_1);
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), (GtkWidget *)start_menu_2);
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), (GtkWidget *)start_menu_4);
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), (GtkWidget *)start_menu_6);
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), (GtkWidget *)start_menu_8);
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), (GtkWidget *)start_menu_10);
  gtk_menu_shell_append(GTK_MENU_SHELL(this->start_menu), (GtkWidget *)start_menu_11);
  gtk_container_add(GTK_CONTAINER(start_menu_0), (GtkWidget *)_12);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(start_menu_0), (GtkWidget *)fft_size_menu);
  gtk_container_add(GTK_CONTAINER(start_menu_1), (GtkWidget *)_13);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(start_menu_1), (GtkWidget *)fft_overlap_menu);
  gtk_container_add(GTK_CONTAINER(start_menu_2), (GtkWidget *)_14);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(start_menu_2), (GtkWidget *)fft_window_menu);
  gtk_container_add(GTK_CONTAINER(start_menu_4), (GtkWidget *)_15);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(start_menu_4), (GtkWidget *)display_menu);
  gtk_container_add(GTK_CONTAINER(start_menu_6), (GtkWidget *)_17);
  gtk_container_add(GTK_CONTAINER(start_menu_8), (GtkWidget *)_19);
  gtk_container_add(GTK_CONTAINER(start_menu_10), (GtkWidget *)_21);
  gtk_container_add(GTK_CONTAINER(start_menu_11), (GtkWidget *)_23);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_1);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_2);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_3);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_4);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_5);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_6);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_7);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_8);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_9);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_10);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_11);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_size_menu), (GtkWidget *)fft_size_menu_12);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_0), (GtkWidget *)_25);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_1), (GtkWidget *)_27);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_2), (GtkWidget *)_29);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_3), (GtkWidget *)_31);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_4), (GtkWidget *)_33);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_5), (GtkWidget *)_35);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_6), (GtkWidget *)_37);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_7), (GtkWidget *)_39);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_8), (GtkWidget *)_41);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_9), (GtkWidget *)_43);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_10), (GtkWidget *)_45);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_11), (GtkWidget *)_47);
  gtk_container_add(GTK_CONTAINER(fft_size_menu_12), (GtkWidget *)_49);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_1);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_2);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_3);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_4);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_5);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_6);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_7);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_8);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_9);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_overlap_menu), (GtkWidget *)fft_overlap_menu_10);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_0), (GtkWidget *)_51);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_1), (GtkWidget *)_53);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_2), (GtkWidget *)_55);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_3), (GtkWidget *)_57);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_4), (GtkWidget *)_59);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_5), (GtkWidget *)_61);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_6), (GtkWidget *)_63);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_7), (GtkWidget *)_65);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_8), (GtkWidget *)_67);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_9), (GtkWidget *)_69);
  gtk_container_add(GTK_CONTAINER(fft_overlap_menu_10), (GtkWidget *)_71);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_window_menu), (GtkWidget *)fft_window_menu_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_window_menu), (GtkWidget *)fft_window_menu_1);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_window_menu), (GtkWidget *)fft_window_menu_2);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_window_menu), (GtkWidget *)fft_window_menu_3);
  gtk_menu_shell_append(GTK_MENU_SHELL(fft_window_menu), (GtkWidget *)fft_window_menu_4);
  gtk_container_add(GTK_CONTAINER(fft_window_menu_0), (GtkWidget *)_73);
  gtk_container_add(GTK_CONTAINER(fft_window_menu_1), (GtkWidget *)_75);
  gtk_container_add(GTK_CONTAINER(fft_window_menu_2), (GtkWidget *)_77);
  gtk_container_add(GTK_CONTAINER(fft_window_menu_3), (GtkWidget *)_79);
  gtk_container_add(GTK_CONTAINER(fft_window_menu_4), (GtkWidget *)_81);
  gtk_menu_shell_append(GTK_MENU_SHELL(display_menu), (GtkWidget *)display_menu_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(display_menu), (GtkWidget *)display_menu_1);
  gtk_container_add(GTK_CONTAINER(display_menu_0), (GtkWidget *)_83);
  gtk_container_add(GTK_CONTAINER(display_menu_1), (GtkWidget *)_85);
  gtk_box_pack_start(GTK_BOX(_86), (GtkWidget *)lb, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_86), (GtkWidget *)rb, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_87), (GtkWidget *)this->state_label, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_87), (GtkWidget *)command_box, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_88), (GtkWidget *)this->d, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_89), (GtkWidget *)this->dsamples, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_90), (GtkWidget *)this->dcol, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_90), (GtkWidget *)rb2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_91), (GtkWidget *)color_label_box, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_92), (GtkWidget *)this->maxdB_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_93), (GtkWidget *)this->hz_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_94), (GtkWidget *)this->db_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_95), (GtkWidget *)this->mindB_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_96), (GtkWidget *)this->color_label_draw, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_97), (GtkWidget *)this->color_label, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_98), (GtkWidget *)this->command, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_99), (GtkWidget *)main_menu, TRUE, TRUE, 0);


  this->command_activate = g_signal_connect(this->command, "activate", G_CALLBACK(_1), this);

  this->d_expose = g_signal_connect(this->d, "expose-event", G_CALLBACK(_2), this);
  this->d_enter = g_signal_connect(this->d, "enter-notify-event", G_CALLBACK(_3), this);
  this->d_leave = g_signal_connect(this->d, "leave-notify-event", G_CALLBACK(_4), this);
  this->d_pointer_motion = g_signal_connect(this->d, "motion-notify-event", G_CALLBACK(_5), this);
  this->d_pointer_press = g_signal_connect(this->d, "button-press-event", G_CALLBACK(_5), this);
  this->d_pointer_release = g_signal_connect(this->d, "button-release-event", G_CALLBACK(_5), this);

  this->dcol_expose = g_signal_connect(this->dcol, "expose-event", G_CALLBACK(_6), this);
  this->dcol_pointer_motion = g_signal_connect(this->dcol, "motion-notify-event", G_CALLBACK(_7), this);
  this->dcol_pointer_press = g_signal_connect(this->dcol, "button-press-event", G_CALLBACK(_7), this);
  this->dcol_pointer_release = g_signal_connect(this->dcol, "button-release-event", G_CALLBACK(_7), this);

  this->dsamples_expose = g_signal_connect(this->dsamples, "expose-event", G_CALLBACK(_8), this);

  this->color_label_draw_pointer_motion = g_signal_connect(this->color_label_draw, "motion-notify-event", G_CALLBACK(_9), this);
  this->color_label_draw_pointer_press = g_signal_connect(this->color_label_draw, "button-press-event", G_CALLBACK(_9), this);
  this->color_label_draw_pointer_release = g_signal_connect(this->color_label_draw, "button-release-event", G_CALLBACK(_9), this);

  this->start_menu_6_activate = g_signal_connect(start_menu_6, "activate", G_CALLBACK(_16), this);

  this->start_menu_8_activate = g_signal_connect(start_menu_8, "activate", G_CALLBACK(_18), this);

  this->start_menu_10_activate = g_signal_connect(start_menu_10, "activate", G_CALLBACK(_20), this);

  this->start_menu_11_activate = g_signal_connect(start_menu_11, "activate", G_CALLBACK(_22), this);

  this->fft_size_menu_0_activate = g_signal_connect(fft_size_menu_0, "activate", G_CALLBACK(_24), this);

  this->fft_size_menu_1_activate = g_signal_connect(fft_size_menu_1, "activate", G_CALLBACK(_26), this);

  this->fft_size_menu_2_activate = g_signal_connect(fft_size_menu_2, "activate", G_CALLBACK(_28), this);

  this->fft_size_menu_3_activate = g_signal_connect(fft_size_menu_3, "activate", G_CALLBACK(_30), this);

  this->fft_size_menu_4_activate = g_signal_connect(fft_size_menu_4, "activate", G_CALLBACK(_32), this);

  this->fft_size_menu_5_activate = g_signal_connect(fft_size_menu_5, "activate", G_CALLBACK(_34), this);

  this->fft_size_menu_6_activate = g_signal_connect(fft_size_menu_6, "activate", G_CALLBACK(_36), this);

  this->fft_size_menu_7_activate = g_signal_connect(fft_size_menu_7, "activate", G_CALLBACK(_38), this);

  this->fft_size_menu_8_activate = g_signal_connect(fft_size_menu_8, "activate", G_CALLBACK(_40), this);

  this->fft_size_menu_9_activate = g_signal_connect(fft_size_menu_9, "activate", G_CALLBACK(_42), this);

  this->fft_size_menu_10_activate = g_signal_connect(fft_size_menu_10, "activate", G_CALLBACK(_44), this);

  this->fft_size_menu_11_activate = g_signal_connect(fft_size_menu_11, "activate", G_CALLBACK(_46), this);

  this->fft_size_menu_12_activate = g_signal_connect(fft_size_menu_12, "activate", G_CALLBACK(_48), this);

  this->fft_overlap_menu_0_activate = g_signal_connect(fft_overlap_menu_0, "activate", G_CALLBACK(_50), this);

  this->fft_overlap_menu_1_activate = g_signal_connect(fft_overlap_menu_1, "activate", G_CALLBACK(_52), this);

  this->fft_overlap_menu_2_activate = g_signal_connect(fft_overlap_menu_2, "activate", G_CALLBACK(_54), this);

  this->fft_overlap_menu_3_activate = g_signal_connect(fft_overlap_menu_3, "activate", G_CALLBACK(_56), this);

  this->fft_overlap_menu_4_activate = g_signal_connect(fft_overlap_menu_4, "activate", G_CALLBACK(_58), this);

  this->fft_overlap_menu_5_activate = g_signal_connect(fft_overlap_menu_5, "activate", G_CALLBACK(_60), this);

  this->fft_overlap_menu_6_activate = g_signal_connect(fft_overlap_menu_6, "activate", G_CALLBACK(_62), this);

  this->fft_overlap_menu_7_activate = g_signal_connect(fft_overlap_menu_7, "activate", G_CALLBACK(_64), this);

  this->fft_overlap_menu_8_activate = g_signal_connect(fft_overlap_menu_8, "activate", G_CALLBACK(_66), this);

  this->fft_overlap_menu_9_activate = g_signal_connect(fft_overlap_menu_9, "activate", G_CALLBACK(_68), this);

  this->fft_overlap_menu_10_activate = g_signal_connect(fft_overlap_menu_10, "activate", G_CALLBACK(_70), this);

  this->fft_window_menu_0_activate = g_signal_connect(fft_window_menu_0, "activate", G_CALLBACK(_72), this);

  this->fft_window_menu_1_activate = g_signal_connect(fft_window_menu_1, "activate", G_CALLBACK(_74), this);

  this->fft_window_menu_2_activate = g_signal_connect(fft_window_menu_2, "activate", G_CALLBACK(_76), this);

  this->fft_window_menu_3_activate = g_signal_connect(fft_window_menu_3, "activate", G_CALLBACK(_78), this);

  this->fft_window_menu_4_activate = g_signal_connect(fft_window_menu_4, "activate", G_CALLBACK(_80), this);

  this->display_menu_0_activate = g_signal_connect(display_menu_0, "activate", G_CALLBACK(_82), this);

  this->display_menu_1_activate = g_signal_connect(display_menu_1, "activate", G_CALLBACK(_84), this);

  {
#if 1
    GIOChannel *chan = g_io_channel_unix_new(jack->jackfd);
    if (!chan) abort();
    g_io_channel_set_encoding(chan, NULL, NULL);
    this->jack_callback = g_io_add_watch_full(chan, G_PRIORITY_LOW /*G_PRIORITY_DEFAULT_IDLE*/,
                              G_IO_IN, _jack_callback, this, NULL);
#else
    this->jack_callback = gtk_input_add_full(jack->jackfd, GDK_INPUT_READ,
                              (GdkInputFunction)jack_callback, 0, this, 0);
#endif
    init_repl(this);
    color_green(this);
    gui_state(this);
    g_timeout_add(1000, stats_timer, this);
    g_signal_connect(this->d, "configure-event", G_CALLBACK(d_resize), this);
    g_signal_connect(this->dcol, "configure-event",
                     G_CALLBACK(dcol_resize), this);
    redraw_lines_colors(this);
    this->redraw_lines(this, 0, this->width-1);
    strcpy(this->colmap.curdir, DEF_COLORMAP_DIR);
  }

  return 0;
}

