/* generated by gtkcooker (http://www.nongnu.org/gtkcooker) */

#ifndef _GUI_H_
#define _GUI_H_

#include "jackend.h"
#include "power_buffer.h"
#include "defs.h"
#include "colors.h"
#include "gui_colors.h"
#include "fft_window.h"



struct mainwin;

void gui_init(void);
void gui_quit(void);
void gui_show(struct mainwin *);
void gui_run(void);
void gui_set_min_freq(struct mainwin *, float);
void gui_set_max_freq(struct mainwin *, float);
void gui_colors_set_mindB(struct mainwin *, float);
void gui_colors_set_maxdB(struct mainwin *, float);
void gui_force_redraw(struct mainwin *);
void gui_force_redraw_colors(struct mainwin *);
void redraw_lines(struct mainwin *, int, int);
void gui_mouse_click(struct mainwin *, int, int, int, int);
void gui_mouse_move(struct mainwin *, int, int);
void gui_mouse_unclick(struct mainwin *);
void redraw_lines_colors(struct mainwin *);
void gui_colors_mouse_click(struct mainwin *, int, int);
void gui_colors_mouse_move(struct mainwin *, int, int);
void gui_colors_mouse_unclick(struct mainwin *);
void gui_state(struct mainwin *);
void gui_fft_size(struct mainwin *, int);
void gui_pause_unpause(struct mainwin *);
void gui_show_colormap_selection(struct mainwin *);
void gui_widget_show_all(void *);
void gui_load_colormap(struct mainwin *, const char *);
void redraw_lines_average(struct mainwin *, int, int);
void redraw_lines_nearest(struct mainwin *, int, int);


typedef struct mainwin {

    jack_stuff *jack;
    colormap colormap;
    unsigned int jack_callback;
    power_buffer f;
    unsigned char *image;
    unsigned char *colors_image;
    unsigned char *dsamples_min;
    unsigned char *dsamples_max;
    int width;
    int height;
    int col_height;
    float min_freq;
    float max_freq;
    int mouse_state;
    int mouse_x;
    int mouse_y;
    float mouse_min_freq;
    float mouse_max_freq;
    int mouse_to_process;
    int mouse_colors_state;
    int mouse_colors_x;
    int mouse_colors_y;
    float mouse_colors_mindB;
    float mouse_colors_maxdB;
    int current_color;
    unsigned long lost_samples;
    float mindB_stats_show;
    float maxdB_stats_show;
    float mindB_stats_overall;
    float maxdB_stats_overall;
    gui_colormap colmap;
    void (*redraw_lines)(struct mainwin *, int, int);
    int pointer_x;
    int pointer_y;
  
  /* GtkWidget* */ void *win;
  /* GtkWidget* */ void *mindB_label;
  /* GtkWidget* */ void *maxdB_label;
  /* GtkWidget* */ void *hz_label;
  /* GtkWidget* */ void *db_label;
  /* GtkWidget* */ void *color_label;
  /* GtkWidget* */ void *state_label;
  /* GtkWidget* */ void *command;
  unsigned long command_activate;
  /* GtkWidget* */ void *d;
  unsigned long d_expose;
  unsigned long d_enter;
  unsigned long d_leave;
  unsigned long d_pointer_motion;
  unsigned long d_pointer_press;
  unsigned long d_pointer_release;
  /* GtkWidget* */ void *dcol;
  unsigned long dcol_expose;
  unsigned long dcol_pointer_motion;
  unsigned long dcol_pointer_press;
  unsigned long dcol_pointer_release;
  /* GtkWidget* */ void *dsamples;
  unsigned long dsamples_expose;
  /* GtkWidget* */ void *color_label_draw;
  unsigned long color_label_draw_pointer_motion;
  unsigned long color_label_draw_pointer_press;
  unsigned long color_label_draw_pointer_release;
  /* GtkWidget* */ void *start_menu;
  unsigned long start_menu_6_activate;
  unsigned long start_menu_8_activate;
  unsigned long start_menu_10_activate;
  unsigned long start_menu_11_activate;
  unsigned long fft_size_menu_0_activate;
  unsigned long fft_size_menu_1_activate;
  unsigned long fft_size_menu_2_activate;
  unsigned long fft_size_menu_3_activate;
  unsigned long fft_size_menu_4_activate;
  unsigned long fft_size_menu_5_activate;
  unsigned long fft_size_menu_6_activate;
  unsigned long fft_size_menu_7_activate;
  unsigned long fft_size_menu_8_activate;
  unsigned long fft_size_menu_9_activate;
  unsigned long fft_size_menu_10_activate;
  unsigned long fft_size_menu_11_activate;
  unsigned long fft_size_menu_12_activate;
  unsigned long fft_overlap_menu_0_activate;
  unsigned long fft_overlap_menu_1_activate;
  unsigned long fft_overlap_menu_2_activate;
  unsigned long fft_overlap_menu_3_activate;
  unsigned long fft_overlap_menu_4_activate;
  unsigned long fft_overlap_menu_5_activate;
  unsigned long fft_overlap_menu_6_activate;
  unsigned long fft_overlap_menu_7_activate;
  unsigned long fft_overlap_menu_8_activate;
  unsigned long fft_overlap_menu_9_activate;
  unsigned long fft_overlap_menu_10_activate;
  unsigned long fft_window_menu_0_activate;
  unsigned long fft_window_menu_1_activate;
  unsigned long fft_window_menu_2_activate;
  unsigned long fft_window_menu_3_activate;
  unsigned long fft_window_menu_4_activate;
  unsigned long display_menu_0_activate;
  unsigned long display_menu_1_activate;
} mainwin;

int init_mainwin(mainwin *this, jack_stuff *jack);

#endif /* _GUI_H_ */
